<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2012 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */

class base_events_service {

    /**
     * The event handler mappings for the application.
     *
     * @var array
     */
    protected $listen = [];

    public function __construct($eventName)
    {
        $listen = config::get('events.listen');
        if( ! $listen[$eventName] )
        {
            throw new Exception('事件未定义');
        }

        $this->listen[$eventName] = $listen[$eventName];
    }

    /**
     * 注册触发事件的listen
     *
     * @param  object base_events_dispatcher $events
     * @return void
     */
    public function boot($events)
    {
        foreach ($this->listen as $event => $listeners)
        {
            foreach( (array)$listeners as $listenerArr )
            {
                list( $listener, $isSync, $priority ) = $listenerArr;
                $isSync = $isSync ? : 'sync';
                $priority = $priority ? : 1;

                $events->listen($event, $listener, $isSync, $priority);
            }
        }
    }

    /**
     * Get the events and handlers.
     *
     * @return array
     */
    public function listens()
    {
        return $this->listen;
    }
}

