<?php

class topshop_ctl_selector_item extends topshop_controller {

    public $limit = 14;

    public function loadSelectGoodsModal()
    {
        $isImageModal = true;
        // $pagedata = $this->searchItem(false);
        $pagedata['imageModal'] = true;
        $pagedata['textcol'] = input::get('textcol');
        $pagedata['view'] = input::get('view');
        $pagedata['shopCatList'] = app::get('topshop')->rpcCall('shop.authorize.cat',array('shop_id'=>$this->shopId));
        return view::make('topshop/selector/item/index.html', $pagedata);
    }

    public function formatSelectedGoodsRow()
    {
        $itemIds = input::get('item_id');
        $textcol = input::get('textcol');
        $extendView = input::get('view');
        $searchParams['fields'] = 'item_id,title,image_default_id,price,brand_id';
        $searchParams['item_id'] = implode(',', $itemIds);
        $itemsList = app::get('topshop')->rpcCall('item.search', $searchParams);

        //特殊判断 有待优化
        if($itemsList['total_found']>40)
        {
            $pages = ceil($itemsList['total_found']/40);

            for($i=2;$i<=$pages;$i++)
            {
                $searchParams = array(
                    'page_no' => $i,
                    'item_id' => implode(',',$itemIds),
                    'fields' => 'item_id,title,image_default_id,cat_id,brand_id,price',
                );
                $itemsListData = app::get('syspromotion')->rpcCall('item.search',$searchParams);
                $itemsList['list'] = array_merge($itemsList['list'],$itemsListData['list']);
            }
        }

        $pagedata['_input']['itemsList'] = $itemsList['list'];
        $pagedata['_input']['view'] = $extendView;
        if(!$textcol)
        {
            $pagedata['_input']['_textcol'] = 'title';
        }
        else
        {
            $pagedata['_input']['_textcol'] = explode(',',$textcol);
        }
        return view::make('topshop/selector/item/input-row.html', $pagedata);
    }

    //根据商家id和3级分类id获取商家所经营的所有品牌
    public function getBrandList()
    {
        $shopId = $this->shopId;
        $catId = input::get('catId');
        $params = array(
            'shop_id'=>$shopId,
            'cat_id'=>$catId,
            'fields'=>'brand_id,brand_name,brand_url'
        );
        $brands = app::get('topshop')->rpcCall('category.get.cat.rel.brand',$params);
        return response::json($brands);
    }

    //根据商家类目id的获取商家所经营类目下的所有商品
    public function searchItem($json=true)
    {
        $shopId = $this->shopId;
        $catId = input::get('catId');
        $brandId = input::get('brandId');
        $keywords = input::get('searchname');
        $pages = input::get('pages');

        // $fullminusId = input::get('fullminusId');
        if($brandId)
        {
            $searchParams = array(
                'shop_id' => $shopId,
                'cat_id' => $catId,
                'brand_id' => $brandId,
                'search_keywords' => $keywords,
                'page_no' => $pages,
                'page_size' => $this->limit,
            );
        }
        else
        {
            $searchParams = array(
                'shop_id' => $shopId,
                'cat_id' => $catId,
                'search_keywords' => $keywords,
                'page_no' => $pages,
                'page_size' => $this->limit,
            );
        }

        $searchParams['fields'] = 'item_id,title,image_default_id,price,brand_id';
        $itemsList = app::get('topshop')->rpcCall('item.search', $searchParams);
        $pagedata['itemsList'] = $itemsList['list'];
        $pagedata['total'] = $itemsList['total_found'];
        $totalPage = ceil($itemsList['total_found']/$this->limit);
        $pagersFilter['pages'] = time();
        $pagers = array(
            'link' => url::action('topshop_ctl_selector_item@searchItem', $pagersFilter),
            'current' => $pages,
            'use_app' => 'topshop',
            'total' => $totalPage,
            'token' => time(),
        );
        $pagedata['pagers'] = $pagers;
        // if($fullminusId)
        // {
        //     $objMdlFullminusItem = app::get('syspromotion')->model('fullminus_item');
        //     $notEndItem = $objMdlFullminusItem->getList('item_id', array('end_time|than'=>time() ) );

        //     $pagedata['notEndItem'] = array_column($notEndItem, 'item_id');
        // }
        // else
        // {
        //      $pagedata['notEndItem'] = array();
        // }
        $pagedata['image_default_id'] = app::get('image')->getConf('image.set');
        // $data = $json ? response::json($pagedata) : $pagedata;
        return view::make('topshop/selector/item/list.html', $pagedata);
    }
}
